; Brown Jenkin
Graphics 320, 240, 16, 1
AppTitle "Brown Jenkin Stupid Contest Demo"
SetBuffer BackBuffer()
SeedRnd(MilliSecs())

; Includes
Include "create.bb"
Include "render.bb"
Include "greetz.bb"

SetBuffer FrontBuffer()
Text 140, 115, "LOADING"
; GFX
; ########################## Main GFX ###########################
Global Jenkin = LoadAnimImage("GFX/jenkin.png", 37, 23, 0, 8)
MaskImage Jenkin, 255, 0, 255
Global Nuzzle = LoadAnimImage("GFX/nuzzle.png", 26, 35, 0, 8)
MaskImage Nuzzle, 255, 0, 255
Global Buzzer = LoadAnimImage("GFX/buzzer.png", 29, 24, 0, 4)
MaskImage Buzzer, 255, 0, 255
Global Witchy = LoadAnimImage("GFX/witchy.png", 44, 44, 0, 12)
MaskImage Witchy, 255, 0, 255
Global ScottFX = LoadAnimImage("GFX/scott.png", 52, 62, 0, 12)
MaskImage ScottFX, 255, 0, 255
Global Shoot = LoadAnimImage("GFX/Shot.png", 8, 8, 0, 4)
MaskImage Shoot, 255, 0, 255
Global Items = LoadAnimImage("GFX/items.png", 16, 16, 0, 6)
MaskImage Items, 255, 0, 255
Status = LoadImage ("GFX/Status.png")
Global Crow = LoadAnimImage("GFX/Crow.png", 64, 56, 0, 4)
Global Bar = LoadImage("GFX/collisionbar.png")
Global Doors = LoadImage("GFX/doors.png")
Global EyeBall = LoadAnimImage("GFX/viola.png", 18, 17, 0, 7)
MaskImage Eyeball, 255, 0, 255
Global Moon = LoadImage("GFX/moon.png")
Global Raster = LoadAnimImage("GFX/Raster.png", 320, 9, 0, 3)
Global Cat = LoadAnimImage("GFX/cat.png", 50, 52, 0, 2)
Global BossArms = LoadAnimImage("GFX/arms.png", 59, 38, 0, 2)

; ########################### Screens ###########################
TitleScreen = LoadImage("GFX/title.png")
MaskImage titlescreen, 20, 20, 20
InfoScreen = LoadImage("GFX/info.png")
MaskImage infoscreen, 20, 20, 20
BioScreen = LoadImage("GFX/bio.png")
MaskImage bioscreen, 80, 80, 80
Global DeathScreen = LoadImage("GFX/Death.png")
MaskImage DeathScreen, 20, 20, 20
Global MidScreen = LoadImage("GFX/MidScreen.png")
MaskImage MidScreen, 20, 20, 20
Level1 = LoadImage("GFX/Level1.png")
MaskImage Level1, 0, 55, 55
Level1B2 = LoadImage("GFX/Level1B2.png")
MaskImage Level1B2, 255, 0, 255
Global Level1B = LoadImage("GFX/Level1B.png")
MaskImage Level1B, 0, 0, 0
Global Level2 = LoadImage("GFX/Level2.png")
MaskImage Level2, 20, 20, 20
Global Level2B = LoadImage("GFX/Level2B.png")
Global Fog = LoadImage("GFX/Fog.png")
Global BossScreen = LoadImage("GFX/preboss.png")
MaskImage BossScreen, 255, 0, 255
Global EndScreen = LoadImage("GFX/endscreen.png")
MaskImage EndScreen, 255, 0, 255
Global Level3 = LoadImage("GFX/level3.png")
MaskImage Level3, 255, 0, 255
Global Level3B = LoadImage("GFX/level3B.png")

; ########################### SFX ###########################
Global ShootSFX = LoadSound("SFX/shot.wav")
Global PopSFX = LoadSound("SFX/pop.wav")
Global BoingSFX = LoadSound("SFX/boing.wav")
Global SplatSFX = LoadSound("SFX/splat.wav")
Global LaughSFX = LoadSound("SFX/laugh.wav")
Global SpellSFX = LoadSound("SFX/spell.wav")
Global JiveSFX = LoadSound("SFX/jive.wav")
Global FlatSFX = LoadSound("SFX/flat.wav")
Global HitSFX = LoadSound("SFX/Hit.wav")
Global CackleSFX = LoadSound("SFX/cackle.wav")
Global UnLockSFX = LoadSound("SFX/unlock.wav")
Global CrowSFX = LoadSound("SFX/crow.wav")
Global BuzzSFX = LoadSound("SFX/buzz.wav")
Global CatSFX = LoadSound("SFX/cat.wav")
Global BurstSFX = LoadSound("SFX/burst.wav")
Global FireSFX = LoadSound("SFX/double.wav")
Global ThunderSFX = LoadSound("SFX/bolt.wav")

; ########################### Vars and Types ###########################
Type Shot
	Field X
	Field Y
	Field F
	Field Frame
	Field ID
	Field D
End Type

Type Nuz
	Field X
	Field Y
	Field F
	Field Frame
End Type

Type Buzz
	Field X
	Field Y
	Field Frame
End Type

Type Witch
	Field X
	Field Y
	Field Frame
	Field F
	Field S
	Field L
	Field ID
End Type

Type Scott
	Field X
	Field Y
	Field L
	Field Frame
	Field F
End Type

Type Item
	Field X
	Field Y
	Field Frame
	Field ID
End Type

Type Bar
	Field X
	Field Y#
	Field D
	Field P
	Field F
End Type

Type Warp
	Field X
	Field Y
	Field S#
	Field D
	Field C1
	Field C2
	Field C3
End Type

Type Bolt
	Field X
	Field Y
End Type

SetBuffer BackBuffer()
Timer = MilliSecs()
Global HaloTimer = MilliSecs()
Global FireTimer = MilliSecs()

Global Waves = 0
Global GreetX = 420
Global LHeight = 0
Global LightX = Rand(20, 320)
Global QX = 0
channel = PlayMusic("SFX/title.mod")

; Greetz Intro
setgreetz()
rendergreetz()

Font = LoadFont(Arial, 12, 12, False, False)
SetFont Font
Goto Title

.Title1
Nuzzle = LoadAnimImage("GFX/nuzzle.png", 26, 35, 0, 8)
Buzzer = LoadAnimImage("GFX/buzzer.png", 29, 24, 0, 4)
Font = LoadFont(Arial, 12, 12, False, False)
SetFont Font
StopChannel Channel
Channel =  PlayMusic("SFX/title.mod")

.Title
SetBuffer BackBuffer()
Global Lives = 5
FlushKeys

DrawImage TitleScreen, 0, 0
Flip()
If KeyHit(1) Then End
If KeyHit(23) Then Goto Info
If Not KeyHit(28) Then Goto Title
Goto Reset2

.Info
DrawImage InfoScreen, 0, 0
Flip
If Not KeyHit(57) Then Goto Info

.Bio
DrawImage BioScreen, 0, 0
Flip
If Not KeyHit(28) Then Goto Bio
Goto Title

.Reset2
Global Score = 0
Global Level = 1

.Reset
If Lives = 0 Then Goto Title1
Global Frame = 0
Global Facing = 0
Global JX = 145
Global JY = 173
Global JS = 0
Global BX = 0
Global Jumping = 0
Global EnemyCount = 0
Global YellowDoor = 1
Global HaveYellowKey = 0
Global JD = 0
Global OldJY
Global Key = 0
Global Scroll = 1
Global Touch = 0
Global Life = 3
Global Halo = 0
Global Ammo = 20
Global D1X = 2942
Global D1Y = 0
Global FogX= 0
Global MoonX# = 340 - 54

; ############################## Boss Variables ################################
Global CatX = 320 - 50
Global CatY = 1
Global ArmX = 320 - 59
Global ArmY = CatY + 30
Global CatS = 0
Global CatL = 10
Global CatD = 1
Global ArmFrame = 0
Global CatFrame = 0

Type Eyes
	Field X
	Field Y
	Field Frame
	Field D
End Type

; ##############################################


CreateItems()
CreateWitchy()
If Level = 2 Then Buzzer = LoadAnimImage("GFX/crow.png", 64, 56, 0, 4)
MaskImage Buzzer, 255, 0, 255

If Level = 3 Then Nuzzle = LoadAnimImage("GFX/eyeball.png", 32, 32, 0, 8)
MaskImage Nuzzle, 255, 0, 255

StopChannel Channel
If Level = 1 Then Channel =  PlayMusic("SFX/level1.mod")
If Level = 2 Then Channel =  PlayMusic("SFX/level2.mod")
If Level = 3 Then Channel =  PlayMusic("SFX/boss.mod")

If Level = 3 Then
	Ammo = 99
	Life = 3
	JX = 1
	JY = 80
EndIf

While Not KeyDown(1)
.Main
If MilliSecs() >= Timer + 100 Then Goto Render Else Goto Main
.Render
Cls
If Level = 1 Then DrawImage Level1B, BX, 0
If Level = 2 Then DrawImage Level2B, BX, 0
If Level = 3 Then DrawImage Level3B, 0, 0

DrawImage Bar, JX, JY + 23

If Level = 1 Then TileImage Level1B2, QX, 1: DrawImage Level1, BX, 0
If Level = 2 Then DrawImage Level2, BX, 0: TileImage Fog, FogX, 0
If Level = 3 Then DrawImage Moon, MoonX, 0: DrawImage Level3, 0, 0: TileImage Fog, FogX, 0

DrawImage Status, 140, 200
DrawImage Items, 141, 218, 3
Color 255, 255, 255
Text 156, 220, "X" + Life

If MilliSecs() >= HaloTimer + 3000 Then Halo = 0

RenderItems()
RenderShot()

If Life = 0 Then Lives = Lives - 1: Death(): Goto Reset
If JY >= 270 Then Death():Goto Reset

ESpawn = Rand(1, 40): ESpawn2 = Rand(1, 40)
ESpawn3 = Rand(1, 3)
If Level = 3 Then 
	ESpawn = Rand(1, 30): ESpawn2 = Rand(1, 30)
	ESpawn3 = 1
EndIf
If ESpawn = ESpawn2 And EnemyCount < 3 Then 
	If ESpawn3 = 1 Then CreateNuzzle()
	If ESpawn3 = 2 Then CreateBuzzer()
	If ESpawn3 = 3 Then CreateScott()
EndIf

If EnemyCount > 0 Then RenderNuzzle(): RenderBuzzer(): RenderScott()

RenderWitchy()
RenderBolt()
If Level = 3 Then RenderCatsEye()

FogX = FogX - 4
If Level = 3 Then MoonX = MoonX - .7

If MoonX <= 0 - 54 Then Lives = Lives - 1: Death(): Goto Reset

If Jumping = 1 Then Jump()

Color 255, 255, 255
Text 145, 203, Score
Text 193, 220, Ammo

If Level <> 1 Then
	; Lightning code
	; ##############################################
	BSpawn1 = Rand(1, 30): BSpawn2 = Rand(1, 30)
	If BSpawn1 = BSpawn2 Then 
	PlaySound ThunderSFX
	For i = 1 To 240 / 4
	CreateBolt()
	Next
	EndIf
	; ##############################################
EndIf

; ################################## BOSS #################################
If Level = 3 Then
	If CatD = 1 Then CatY = CatY + 8
	If CatD = 0 Then CatY = CatY - 8
	DrawImage Cat, CatX, CatY, CatFrame
	ArmY = CatY + 30
	If CatS = 0 And CatY > 20 Then CreateCatsEye()
	
	DrawImage BossArms, ArmX, ArmY, ArmFrame
	If CatY <= 0 Then CatY = 1: CatD = 1: CatFrame = 0: ArmFrame = 0
	If CatY >= 80 Then CatY = 79: CatD = 0: CatFrame = 0: ArmFrame = 0

	If ImagesCollide(Jenkin, JX, JY, Frame, Cat, CatX, CatY, CatFrame) And Halo = 0 Then
        PlaySound LaughSFX
		Life = Life - 1
	    Halo = 1
		HaloTimer = MilliSecs()
		If Life <= 0 Then Life = 0
	EndIf
	
	If ImagesCollide(Jenkin, JX, JY, Frame, BossArms, ArmX, ArmY, ArmFrame) And Halo = 0 Then
        PlaySound LaughSFX
		Life = Life - 1
	    Halo = 1
		HaloTimer = MilliSecs()
		If Life <= 0 Then Life = 0
	EndIf
	
	If CatL <= 0 Then 
		StopChannel Channel
		Channel = PlayMusic("SFX/ending.mod")
		Goto Ending
	EndIf
EndIf


; ##############################################

If HaveYellowKey = 1 And Level = 1 Then DrawImage Items, 180, 215, 4
If YellowDoor = 1 And Level = 1 Then DrawImage Doors, D1X, D1Y

If Level = 1 Then
If ImagesCollide(Bar, JX, JY + 23, 0, Level1B, BX, 0, 0) Then 
	Touch = 1
	If Jumping = 1 Then Jumping = 0
EndIf
EndIf

If Level = 2 Then
If ImagesCollide(Bar, JX, JY + 23, 0, Level2B, BX, 0, 0) Then 
	Touch = 1
	If Jumping = 1 Then Jumping = 0
	EndIf
EndIf

If Level = 3 Then
If ImagesCollide(Bar, JX, JY + 23, 0, Level3B, BX, 0, 0) Then 
	Touch = 1
	If Jumping = 1 Then Jumping = 0
	EndIf
EndIf


If Level = 1 Then
If Not ImagesCollide(Bar, JX, JY + 23 ,0, Level1B, BX, 0, 0) Then
	Touch = 0
	If Jumping = 0 Then JY = JY + 8
EndIf
EndIf

If Level = 2 Then
If Not ImagesCollide(Bar, JX, JY + 23 ,0, Level2B, BX, 0, 0) Then
	Touch = 0
	If Jumping = 0 Then JY = JY + 8
EndIf
EndIf

If Level = 3 Then
If Not ImagesCollide(Bar, JX, JY + 23 ,0, Level3B, BX, 0, 0) Then
	Touch = 0
	If Jumping = 0 Then JY = JY + 8
EndIf
EndIf

Timer = MilliSecs()

DrawImage Jenkin, JX, JY, Frame
Frame = Frame + 1
If Frame = 4 And Facing = 0 Then Frame = 0
If Frame = 8 And Facing = 1 Then Frame = 4

If BX < -2800 And Level = 1 Then Level = 2: Goto Cleanup 
If BX < -2800 And Level = 2 Then Goto Boss
If Halo = 1 Then 
Color 255, 255, 0
	If Facing = 0 Then Oval JX + 27, JY, 10, 5, 0
	If Facing = 1 Then Oval JX, JY, 10, 5, 0
EndIf

If KeyDown(59) Then CreateNuzzle()
If KeyDown(157) And JS = 0 And Ammo > 0 Then CreateShot(1)
If KeyDown(57) And Jumping = 0 And Touch = 1 Then JD = 0: OldJY = JY: PlaySound BoingSFX: Jump()

If KeyDown(59) Then SaveBuffer(BackBuffer(),"C:\SS1.BMP")
If KeyDown(203) Then 
If Facing = 0 Then Frame = 4
Scroll = 1: Facing = 1
Goto leave
EndIf

If KeyDown(205) Then
If ImagesCollide(Jenkin, JX, JY, Frame, Doors, D1X, D1Y, 0) And Level = 1 Then Scroll = 2: Goto leave
If Facing = 1 Then Frame = 0
Scroll = 0: Facing = 0
Goto leave
EndIf

If facing = 0 Then frame = 0
If facing = 1 Then frame = 4

Scroll = 2
.Leave
MapScroll()
Flip False
Wend

End


Function MapScroll()
If Level = 3 Then Goto Level3Scroll
If Scroll = 0 Then 
For brown.shot = Each shot
	brown\X = brown\X - 8
Next

For zle.Nuz = Each Nuz
	zle\X = zle\X - 8
Next

For cheese.Item = Each Item
	cheese\X = cheese\X - 8
Next

For er.Buzz = Each Buzz
 er\X = er\X - 8
Next

For evil.Witch = Each Witch
	evil\X = evil\X - 8
Next

For the.Scott = Each Scott
   the\X = the\X - 8
Next
Qx = Qx - 1
D1X = D1X - 8
FogX = FogX - 9
BX = BX - 8
EndIf

If Scroll = 1 And BX <> 0 Then 
For brown.shot = Each shot
	brown\X = brown\X + 8
Next

For zle.Nuz = Each Nuz
 zle\X = zle\X + 8
Next

For cheese.Item = Each Item
	cheese\X = cheese\X + 8
Next

For er.Buzz = Each Buzz
 er\X = er\X + 8
Next

For evil.Witch = Each Witch
	evil\X = evil\X + 8
Next

For the.Scott = Each Scott
 the\X = the\X + 8
Next
QX = QX + 1
D1X = D1X + 8
Bx = BX + 8
EndIf

If BX >= -1 Then BX = 0
If JX < 1 Then JX = 1

.Level3Scroll
If Level = 3 Then
If Scroll = 1 Then JX = JX - 8
If Scroll = 0 Then JX = JX + 8
If JX <= 0 Then JX = 1
If JX >= 340 - 50 Then JX = 340- 51
EndIf
End Function

Function Jump()
If JD = 0 Then JY = JY - 8
If JY <= OldJY - 60 Then JD = 1
If JD = 1 Then JY = JY + 8
Jumping = 1
If JY = OldJY Then Jumping = 0
End Function

; Death/Cleanup
Function Death()
.Title
DrawImage DeathScreen, 0, 0
Text 3, 1, "Lives: "+ Lives 
Flip()
SetBuffer(FrontBuffer())
If Not KeyDown(28) Then Goto Title
SetBuffer BackBuffer()

For brown.shot = Each shot
	Delete brown
Next
For zle.nuz = Each Nuz
	Delete zle
Next
For er.Buzz = Each Buzz
	Delete er
Next
For evil.Witch = Each Witch
	Delete evil
Next
For the.Scott = Each Scott
	Delete the
Next
For cheese.Item = Each Item
	Delete cheese
Next

For E.Eyes = Each Eyes
	Delete e
Next

EnemyCount = 0

End Function

.Cleanup
DrawImage MidScreen, 0, 0
Flip()
SetBuffer(FrontBuffer())
If Not KeyDown(28) Then Goto Cleanup
SetBuffer BackBuffer()
For brown.shot = Each shot
	Delete brown
Next
For zle.nuz = Each Nuz
	Delete zle
Next
For er.Buzz = Each Buzz
	Delete er
Next
For evil.Witch = Each Witch
	Delete evil
Next
For the.Scott = Each Scott
	Delete the
Next
For cheese.Item = Each Item
	Delete cheese
Next

EnemyCount = 0
Goto Reset

.Boss
DrawImage BossScreen, 0, 0
Flip()
SetBuffer FrontBuffer()
If Not KeyDown(28) Then Goto Boss
SetBuffer BackBuffer()
For brown.shot = Each shot
	Delete brown
Next
For zle.nuz = Each Nuz
	Delete zle
Next
For er.Buzz = Each Buzz
	Delete er
Next
For evil.Witch = Each Witch
	Delete evil
Next
For the.Scott = Each Scott
	Delete the
Next
For cheese.Item = Each Item
	Delete cheese
Next
EnemyCount = 0
Level = 3
Goto Reset

.Ending
FlushKeys
DrawImage EndScreen, 0, 0
Text 1,1,"Final Score: " + Score
Flip()
SetBuffer FrontBuffer()
If Not KeyHit(28) Then Goto Ending
setgreetz()
.Credits
SetBuffer BackBuffer()
rendergreetz()
Flip
If Not KeyHit(28) Then Goto Credits
For brown.shot = Each shot
	Delete brown
Next
For zle.nuz = Each Nuz
	Delete zle
Next
For er.Buzz = Each Buzz
	Delete er
Next
For evil.Witch = Each Witch
	Delete evil
Next
For the.Scott = Each Scott
	Delete the
Next
For cheese.Item = Each Item
	Delete cheese
Next

For E.Eyes = Each Eyes
	Delete e
Next
Goto Title1

